
#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
# Nicolas Pécheux <info.cpge@cpge.info>
# Friday, 30 November 2018
# http://cpge.info
#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

import math

## Partie 3 : 

class FactorielTest(unittest.TestCase):
    
    def test_01_factoriel_01(self):
        self.assertTrue(_P.est_factoriel(math.factorial(10000)))


class PremiersNonFactorielsTest(unittest.TestCase):
    
    def test_02_premiers_non_factoriels_01(self):
        self.assertEqual(_P.nombres_premiers_non_factoriels(29),
                         [11, 13, 17, 19, 29])


## Partie 4 : 

class MajoriteAbsolueTest(unittest.TestCase):
    
    def test_03_majorite_absolue_01(self):
        vote_ex = [123456789101112, 666, 123456789101112]
        self.assertFalse(_P.majorite_absolue(vote_ex, 666))


class GagnantTour1Test(unittest.TestCase):
    
    def test_04_gagnant_tour1_01(self):
        vote_ex = [123456789101112, 666, 123456789101112]
        self.assertEqual(_P.gagnant_tour1(vote_ex), 123456789101112)


class GagnantTour1LineaireTest(unittest.TestCase):
    
    def test_05_gagnant_tour1__lineaire_01(self):
        vote_ex = [666, 123456789101112, 123456789101112]
        self.assertEqual(_P.gagnant_tour1_lineaire(vote_ex), 123456789101112)


class GagnantTour2Test(unittest.TestCase):
    
    def test_06_gagnant_tour2_01(self):
        vote_ex = [123456789101112, 666, 123456789101112, 666, 1, 12, 100000]
        self.assertEqual(sorted(_P.gagnant_tour2(vote_ex)), 
                         [666, 123456789101112])


class GagnantTour2LineaireTest(unittest.TestCase):
    
    def test_07_gagnant_tour2__lineaire_01(self):
        vote_ex = [1, 12, 666, 666, 10000, 123456789101112, 123456789101112]
        self.assertEqual(sorted(_P.gagnant_tour2_lineaire(vote_ex)),
                         [666, 123456789101112])


## Tests

TESTS = {
    "01_est_factoriel": FactorielTest,
    "02_premiers_non_factoriels": PremiersNonFactorielsTest,
    "03_majorite_absolue": MajoriteAbsolueTest,
    "04_gagnant_tour1": GagnantTour1Test,
    "05_gagnant_tour1_lineaire": GagnantTour1LineaireTest,
    "06_gagnant_tour2": GagnantTour2Test,
    "07_gagnant_tour2_lineaire": GagnantTour2LineaireTest
}
